"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GraphQLDirective = exports.MapperKind = void 0;
// @ts-ignore
var utils_1 = require("@graphql-tools/utils");
Object.defineProperty(exports, "MapperKind", { enumerable: true, get: function () { return utils_1.MapperKind; } });
var schema_1 = require("@graphql-tools/schema");
var apollo_server_express_1 = require("apollo-server-express");
function GraphQLDirective(typeDefs, callback) {
    if (typeof typeDefs == "string") {
        typeDefs = (0, apollo_server_express_1.gql)(typeDefs);
    }
    var declarations = [];
    for (var _i = 0, _a = typeDefs.definitions; _i < _a.length; _i++) {
        var def = _a[_i];
        var name_1 = def.name.value;
        var args = (def.arguments || []).map(function (o) { return ({
            name: o.name.value,
            type: o.type.name.value,
            defaultValue: o.defaultValue,
        }); });
        // @ts-ignore
        var locations = def.locations.map(function (o) { return utils_1.MapperKind[o.value]; });
        declarations.push({
            name: name_1,
            args: args,
            locations: locations
        });
    }
    return {
        typeDefs: typeDefs,
        apply: function (schema) {
            schema = (0, schema_1.mergeSchemas)({
                schemas: [schema],
                typeDefs: typeDefs,
            });
            var _loop_1 = function (declaration) {
                var cb = function (fieldConfig) {
                    var _a;
                    var directive = (_a = (0, utils_1.getDirective)(schema, fieldConfig, declaration.name)) === null || _a === void 0 ? void 0 : _a[0];
                    if (directive) {
                        if (fieldConfig.resolve) {
                            var resolve_1 = fieldConfig.resolve;
                            fieldConfig.resolve = function (source, args, context, info) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var res;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                res = callback(source, args, context, info, resolve_1);
                                                if (!(res != undefined)) return [3 /*break*/, 3];
                                                if (!(res instanceof Promise)) return [3 /*break*/, 2];
                                                return [4 /*yield*/, res];
                                            case 1:
                                                res = _a.sent();
                                                _a.label = 2;
                                            case 2: return [2 /*return*/, res];
                                            case 3: return [4 /*yield*/, resolve_1(source, args, context, info)];
                                            case 4: return [2 /*return*/, _a.sent()];
                                        }
                                    });
                                });
                            };
                        }
                    }
                    else {
                        if (fieldConfig.resolve) {
                            var resolve_2 = fieldConfig.resolve;
                            fieldConfig.resolve = function (source, args, context, info) {
                                var _a, _b, _c;
                                return __awaiter(this, void 0, void 0, function () {
                                    var dir, typeMap_1, name_2, args2, res;
                                    return __generator(this, function (_d) {
                                        switch (_d.label) {
                                            case 0:
                                                if (!(((_c = (_b = (_a = info === null || info === void 0 ? void 0 : info.fieldNodes) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.directives) === null || _c === void 0 ? void 0 : _c.length) > 0)) return [3 /*break*/, 5];
                                                dir = info.fieldNodes[0].directives.find(function (o) { return o.name.value == declaration.name; });
                                                if (!dir) return [3 /*break*/, 5];
                                                typeMap_1 = schema.getTypeMap();
                                                name_2 = dir.name.value;
                                                args2 = Object.assign.apply(Object, __spreadArray([{}], dir.arguments.map(function (o) {
                                                    var _a;
                                                    return (_a = {},
                                                        _a[o.name.value] = typeMap_1[o.value.kind.split('Value').slice(0, -1)].serialize(o.value.value),
                                                        _a);
                                                }), false));
                                                res = callback.call({
                                                    name: name_2,
                                                    fieldArgs: args,
                                                }, source, args2, context, info, resolve_2);
                                                if (!(res != undefined)) return [3 /*break*/, 3];
                                                if (!(res instanceof Promise)) return [3 /*break*/, 2];
                                                return [4 /*yield*/, res];
                                            case 1:
                                                res = _d.sent();
                                                _d.label = 2;
                                            case 2: return [2 /*return*/, res];
                                            case 3: return [4 /*yield*/, resolve_2(source, args, context, info)];
                                            case 4: return [2 /*return*/, _d.sent()];
                                            case 5: return [4 /*yield*/, resolve_2(source, args, context, info)];
                                            case 6: return [2 /*return*/, _d.sent()];
                                        }
                                    });
                                });
                            };
                        }
                    }
                    return fieldConfig;
                };
                schema = (0, utils_1.mapSchema)(schema, Object.fromEntries(declaration.locations.map(function (kind) { return [
                    kind, cb
                ]; })));
            };
            for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
                var declaration = declarations_1[_i];
                _loop_1(declaration);
            }
            return schema;
        }
    };
}
exports.GraphQLDirective = GraphQLDirective;
// import { createSchema } from '../../graphql/schema';
// export const Pagination = GraphQLDirective(gql`
//     directive @page(n: Int = 1, size: Int) on QUERY | FIELD | FIELD_DEFINITION
//     directive @pagination(page: Int, size: Int) on FIELD | FIELD_DEFINITION
// `, function(source, args, context, info, resolve) {
//     console.log('pagination', args);
//     context.page = args.page || args.n;
//     context.pageSize = args.size;
// })
// export const Order = GraphQLDirective(gql`
//     directive @order(
//         """
//         ascending order
//         """
//         asc: String, 
//         """
//         descending order
//         """
//         desc: String,
//         """
//         random order
//         """
//         random: String
//     ) on FIELD
// `, function(source, args, context, info, resolve) {
//     context.order = Object.assign(context.order || {}, {
//         [args.asc || args.desc]: args.asc ? 1 : -1
//     })
//     console.log(context.order);
// })
// let schema = createSchema({
//     directives: [
//         Pagination
//     ]
// })
// graphql(schema, `
// query {
//     posts @page(n: 5, size: 4) {
//         title
//     }
// }
// `).then(console.log);
